/**

*/

class Box<T>
{
   private T x;
   public Box()
   {
      this.x = null;
   }
   public Box(T x)
   {
      this.x = x;
   }
   public T getX() { return this.x; }
   public Box<T> setX(T x) {this.x = x; return this;}
   public String toString(){return this.x.getClass().getName();}
}

public class TypeInference_v2
{
   public static Box<Integer> methodA()
   {
      return new Box<>(); // What type of Box?
   }

   public static Box<Double> methodB()
   {
      return new Box<>(); // What type of Box?
   }

   public static <T> Box<T> methodC()
   {
      return new Box<>(); // What type of Box?
   }

   public static <T> Box<T> methodD(T in)
   {
      return new Box<>(in); // What type of Box?
   }


   public static void main(String[] args)
   {
      System.out.println( methodA().setX(4) );
    //System.out.println( methodA().setX(4.0) );
      System.out.println( methodB().setX(4.0) );
    //System.out.println( methodB().setX(4) );
      System.out.println( methodC().setX(4).setX(4.0) );

      System.out.println( methodD(4) );
      System.out.println( methodD(4.0) );
      System.out.println( methodD(4).setX(4.0) );
      System.out.println( methodD(4.0).setX(4) );

      Box<Integer> b1 = methodC();  // a Box<Integer> reference variable CANNOT
      b1.setX(4);                   // refer to a Box<Object> object, so methodC()
                                    // really does return here a Box<Integer> object

      // when do you "stop" doing type inference and "start" doing type checking?
//      Box<Integer> b2 = methodC().setX(4);    // why isn't the type of setX's parameter
//      Box<Integer> b3 = methodC().setX(4.0);  // used as part of the type inference?

//      Box<Integer> b4 = new Box<Object>();
//      Box<Object>  b5 = new Box<Integer>();

   }
}
